#!/usr/bin/perl
# cgi-irc v0.3.4 - http://cgiirc.sourceforge.net/
# (C) 1999-2000 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# This deals with the userlist, it takes the users over the unix-domain socket 
# and prints a nice form for the user to do stuff with the users, which it
# sends back to nph-irc.cgi over the unix-domain socket

use strict;
my $version="0.3.4";
use vars qw(%config %irc %colours %styles $channel $say $rand $sock);
use IO::Socket;
use CGI;
my $q = new CGI;
print $q->header();

# Change this if you change the location of the config file
$config{file}="config";
&config($config{file});
$rand=$q->param('r');
$rand=~ s/[^a-z,0-9]//g;

if(my $action=$q->param('action')){
   &connect_u($rand);
   if($action eq "whois"){
	  my $user=$q->param('user');
	  $user =~ s/^(\@|\+)//;
	  &send_u("/whois ".$user."\n");
   }
   elsif($action eq "ping"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/ping ".$user."\n");
   }
   elsif($action eq "op"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/op ".$user."\n");
   }
   elsif($action eq "voice"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/voice ".$user."\n");
   }
   elsif($action eq "deop"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/deop ".$user."\n");
   }
   elsif($action eq "devoice"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/devoice ".$user."\n");
   }
   elsif($action eq "kick"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/kick ".$user."\n");
   }
   elsif($action eq "ban"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/ban ".$user."\n");
   }
   elsif($action eq "query"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/query ".$user."\n");
   }
   &close_u;
}
&main;

sub main{
   &styles;
   &connect_u($rand) or error();
   my ($dummy,$channel) = status_u();
   print <<EOF;
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "dtd/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="se" lang="se"><head>
    <title>
      Userlist
    </title>
    <link rel="Index" href="/index.html" />
    <link rel="Help" href="/meta/sidguide.html" />
    <link rel="Stylesheet" href="/meta/psi.css" type="text/css" />
  </head>
  <body>
    <div align="center">
      <img border="0" src="$config{imagepath}$config{image}"
   width="85" height="64" />
      <form action="$ENV{SCRIPT_NAME}?r=$rand" method="post">
      <p><b>$channel</b><br />
      <tt><input type="hidden" name="r" value="$rand" />
      <select name="user" size="9">
EOF
   my $width = 13;
   my $pad = "";
   my @userlist=userlist($channel);
   @userlist=sort(@userlist);
   for(@userlist){
          if(/^\@/){
		length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
                 print "<option value=\"$_\">$_$pad</option>\n";
          }
   }
   for(@userlist){
          if(/^\+/){
		length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
                 print "<option value=\"$_\">$_$pad</option>\n";
          }
   }
   for(@userlist){
          if($_ !~ /^(\+|\@)/){
		length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
                 print "<option value=\"$_\">$_$pad</option>\n";
          }
   }
   &close_u;
   print <<EOF;
  </select><br />
<!--
   <select name="action">
      <option value="whois" selected>Whois</option>
      <option value="query">Query</option>
      <option value="ping">Ping</option>
      <option value="op">Op</option>
      <option value="voice">Voice</option>
      <option value="deop">Deop</option>
      <option value="devoice">Devocie</option>
      <option value="kick">Kick</option>
      <option value="ban">Ban</option>
      </select></tt><input alt="Do" border="0" src="$config{imagepath}button-do.gif"
            type="image" width="30" height="20" align="top"></p>
-->
         </form>
   </div>

<p><a href="userlist.cgi?r=$rand">Ladda om anvndarlistan</a></p>

<p><a href="irc.cgi" target="_top">Starta om chatten</a></p>

<p><a href="/member/mail.cgi?/member/chat/frames" target="_top">Ge oss frslag fr
denna chatt!</a></p>

<p><a href="/index.html" target="_top">Hem</a></p>

   </body></html>

EOF
}

sub styles{
   $::style=$q->param('style');
   if($q->param('style')){

($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp}) =
split(/:/,$styles{$q->param('style')});
   }else{

($colours{bgcolor},$colours{text},$colours{client},$colours{enter},$colours{channel},$colours{server},$colours{mesg},$colours{action},$colours{ctcp}) =
split(/:/,$styles{$config{default_style}});
   }
}

sub error{
   my $error=shift;
   if($q->param('first')){
	  print "<html><head><noscript><meta http-equiv=\"Refresh\" content=\"5; $ENV{SCRIPT_NAME}?r=$rand\"><noscript><body bgcolor=\"$colours{bgcolor}\" text=\"$colours{text}\">Loading...<br>Please Wait <br><br><br><br><a href=\"irc.cgi\" target=\"_top\">Login again?</a></body></html>\n";
   }else{
	  print "<html><head><body bgcolor=\"$colours{bgcolor}\" text=\"$colours{text}\"><a href=\"irc.cgi\" target=\"_top\">Login again!</a></body></html>"
   }
   exit;
}

sub connect_u{
   my $random=shift;
   $sock = IO::Socket::UNIX->new(
      Peer => "$config{tmpfile_prefix}$random") or return undef;
}

sub userlist{
   $channel=shift;
   print $sock "/CHANNELUSERLIST $channel\n";
   chomp(my $tmp=<$sock>);
   return 0 if $tmp eq 1;
   return split(/ /, $tmp);
}

sub status_u{
   print $sock "/STATUS\n";
   my($c,$d,$n,$s);
   $c=<$sock>;
   $d=<$sock>;
   $n=<$sock>;
   $s=<$sock>;
   chomp($c,$d,$n,$s);
   return($c,$d,$n,$s);
}

sub send_u{
   my $send=shift;
   print $sock $send,"\n";
}

sub close_u{
   print $sock "/CLOSESOCKET\n";
   close($sock);
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or die("Unable to open config file");
   while(<CONFIG>){
      chomp;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);
}


